import os, struct
from PIL import Image

with open("D:\\Games\\DOS\\Jazz1\\MAINCHAR.000", "wb") as output:
    spritesToMask = [41,42,43,44, 48,49,50,51,52, 54,55,56,57,58,59,60,61, 67, 69,70,71,72,73, 78,79,80, 84, 88, 98, 101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127, 129,130,131,132,133,134,135,136,137,138, 145,146,147, 187,188, 190, 201,202,203,204,205,206,207,208,209,210,211,212, 215,216,217,218, 230]
    numberOfSprites = 231
    output.write(struct.pack("h", numberOfSprites))
    for id in range(numberOfSprites):
            try:
                img = Image.open(f"D:\\Games\\DOS\\Jazz1\\MAINCHAR beta\\MC00-{id:03}.BMP")
            except:
                output.write(b'\xff\xff')
                continue
            imgdata = img.getdata()
            quarterWidth = img.width // 4
            output.write(struct.pack("hh", quarterWidth, img.height))
            if id in spritesToMask: #masked
                maskRunningTotal = bytearray([0,0])
                maskData = bytearray()
                pixelData = bytearray([0] * quarterWidth)
                nonZeroMaskBytes = 0
                for y in range(img.height):
                    for x in range(0, img.width, 4):
                        maskByte = 0
                        for q in range(4):
                            if imgdata[x + q + y * img.width] < 254:
                                maskByte |= 1 << q
                        if maskByte != 0:
                            nonZeroMaskBytes += 1
                        maskData.append(maskByte)
                    maskRunningTotal.extend(struct.pack('h', nonZeroMaskBytes))
                for q in range(4):
                    for y in range(img.height):
                        for x in range(q, img.width, 4):
                            if (maskData[(x + y * img.width) // 4] != 0):
                                pixelData.append(imgdata[x + y * img.width])
                output.write(struct.pack("hhh", (img.height + 1) * quarterWidth, len(maskRunningTotal), nonZeroMaskBytes))
                output.write(maskRunningTotal)
                output.write(maskData)
                output.write(pixelData)
            else: #unmasked
                output.write(struct.pack("hhh", len(imgdata) // 4, 0, -1))
                columns = bytearray()
                for q in range(4):
                    for y in range(img.height):
                        for x in range(q, img.width, 4):
                            columns.append(imgdata[x + y * img.width])
                output.write(columns)
